#include <IRremote.h>

//Der IR-Code, mit dem das Licht eingeschaltet wird.
const unsigned long Code_Einschalten = 0x3AC5;

//Der IR-Code, mit dem das Licht ausgeschaltet wird.
const unsigned long Code_Ausschalten = 0xFFFFBA45;

//Wird als nächstes das Licht ein- oder ausgeschaltet?
boolean wird_eingeschalten = false;

//IR-Sender aus der Bibliothek IRemote
IR_Sender IR_Sender;

void setup()
{
  //Für Statusmeldungen und Debugging.
  Serial.begin(9600);
}

void loop() {
  //Der zu übermittelnde IR-Code.
  unsigned long Code;

  //Schaue, welcher Code übertragen werden soll.
  if(wird_eingeschalten) {
    Serial.println("Schalte das Licht ein!");
    Code = Code_Einschalten;
  } 
  else {
    Serial.println("Schalte das Licht aus!");
    Code = Code_Ausschalten;
  }

  //Übermittle den Code.
  //Sende 3, damit im Fall einer Störung 
  //die Chance der erfolgreichen Übertragung steigt.
  for (int i = 0; i < 1; i++) {   
    IR_Sender.sendSony(Code, 32);
    delay(133);
  }

  //Lasse das Licht eine Weile Ein- oder Ausgeschaltet.
  delay(500);

  //Wenn das Licht eingeschaltet wurde, schalte
  //es als nächstes aus (andersrum ebenfalls).
  wird_eingeschalten = !wird_eingeschalten;
}
