#include "font.h"

const int ST_CP_Pin = 6;
const int SH_CP_Pin = 4;
const int SD_Pin = 2;

const int pinX = A0;
const int pinY = A1;
const int pinZ = A2;

boolean nachRechts = true;

boolean peak_erreicht = false;
boolean sensorNachRechts;

void setup() {
  pinMode(ST_CP_Pin, OUTPUT);
  pinMode(SD_Pin, OUTPUT);
  pinMode(SH_CP_Pin, OUTPUT);

  pinMode(pinX, INPUT);
  pinMode(pinY, INPUT);
  pinMode(pinZ, INPUT);

  Serial.begin(115200);
  delay(3000);
}

unsigned long derzeitige_Zeit; //Welche Zeit (in ms) haben wir?
const int mittelWert = 337; // (3.3V / 2) / 5V * 1024
int alterWert; //Der Sensorwert der letzten Messung
//Wann war der letzte Nulldurchgang (Mitte eines Schwenks)
unsigned long letzter_Nulldurchgang = 0;
int letzte_Dauer; //Wie lange war der letzte Schwenk?
int vorletzte_Dauer; //Wie lange war der vorletzte Schwenk?

void werteSensorAus() {
  int sensorWert = analogRead(pinY);

  //Gibt es einen Nulldurchgang?
  if (sensorWert > mittelWert && alterWert <= mittelWert
      || sensorWert < mittelWert && alterWert >= mittelWert) {

    //Ist seit dem letzten Nulldurchgang genug Zeit verstrichen?
    if (derzeitige_Zeit - letzter_Nulldurchgang > 200) {
      vorletzte_Dauer = letzte_Dauer;
      letzte_Dauer = derzeitige_Zeit - letzter_Nulldurchgang;
      letzter_Nulldurchgang = derzeitige_Zeit;
      peak_erreicht = false;
      //War der Nulldurchgang von links nach rechts?
      sensorNachRechts = sensorWert > mittelWert;
    }
  }
  alterWert = sensorWert;
}


int pos = 0;
int zeichenPos = 0;
String text = "   HALLO WELT   ";

unsigned int derzeitige_Zeit_pro_Segment = 1200;//µs

void schwenk_zuende() {
  peak_erreicht = true;
  nachRechts = !sensorNachRechts;
  float tmp = (float)vorletzte_Dauer * 1000.0f / (16.0f * (float)text.length());
  derzeitige_Zeit_pro_Segment = (unsigned int)tmp;
  Serial.print((unsigned long)vorletzte_Dauer);
  Serial.print(";");
  Serial.println((unsigned int)derzeitige_Zeit_pro_Segment);
  if (nachRechts) {
    pos = 0;
    zeichenPos = 0;
  } else {
    pos = 15;
    zeichenPos = text.length() - 1;
  }
}

void schiebe_Position() {
  if (nachRechts) {
    pos++;
    if (pos >= 16) {
      pos = 0;
      zeichenPos++;
    }
    if (zeichenPos >= text.length()) {
      schalteLEDs(0, 0);
      return;
    }
  } else {
    schalteLEDs(0, 0);
    return;
    pos--;
    if (pos < 0) {
      pos = 15;
      zeichenPos--;
    }
    if (zeichenPos < 0) {
      schalteLEDs(0, 0);
      return;
    }
  }
}

void zeige_Teilnachricht() {
  unsigned int lower = pgm_read_word(&myfont[text[zeichenPos]][pos * 2]);
  unsigned int higher = pgm_read_word(&myfont[text[zeichenPos]][pos * 2 + 1]);
  schalteLEDs(lower, higher);
  delayMicroseconds(derzeitige_Zeit_pro_Segment - 396);
}

boolean buff;

void schalteLEDs(byte lower, byte higher) {
  buff = bitRead(higher, 1);
  bitWrite(higher, 1, bitRead(higher, 2));
  bitWrite(higher, 2, buff);

  digitalWrite(ST_CP_Pin, LOW);

  digitalWrite(SH_CP_Pin, LOW);
  shiftOut(SD_Pin, SH_CP_Pin, LSBFIRST, higher);
  shiftOut(SD_Pin, SH_CP_Pin, LSBFIRST, lower);

  digitalWrite(ST_CP_Pin, HIGH);
}

void loop() {
  int sensor = analogRead(pinY);
  Serial.println(sensor);
  }

void loop_t() {
  derzeitige_Zeit = millis();
  werteSensorAus();

  if (derzeitige_Zeit > letzter_Nulldurchgang + vorletzte_Dauer / 2 && !peak_erreicht) {
    schwenk_zuende();
  }

  schiebe_Position();

  zeige_Teilnachricht();
}
