const int pin_IR = 3;     //Pin zur Basis des Transistors Q1
const int pin_taster = 5; //Pin zum Taster S1

void setup() {
  pinMode(pin_IR, OUTPUT);   //Pin als Ausgang initialisieren
  digitalWrite(pin_IR, LOW); //LED ausschalten

  pinMode(pin_taster, INPUT);//Pin als Eingang initialisieren
  digitalWrite(pin_taster, HIGH); //Aktiviere den PullUp-Widerstand
}

// Methode zum Auslösen einer Canon-Kamera
void CanonAusloesen(boolean verzoegerung) {
  //Sende 16 Impulse mit einer Frequenz von ~32kHz.
  for (int i = 0; i < 16; i++) 
  {
    digitalWrite(pin_IR, HIGH);
    delayMicroseconds(11);
    digitalWrite(pin_IR, LOW);
    delayMicroseconds(11);
  }

  //Die Fernauslösung der Canon kennt zwei Modi, Direktauslösung
  //und verzögerte Auslösung, die über die Zeit zwischen den zwei
  //Impulsfolgen unterschieden werden.
  if (verzoegerung) 
  {
    delayMicroseconds(5360);
  } else {
    delayMicroseconds(7330);
  }

  //Sende 16 Impulse mit einer Frequenz von ~32kHz.
  for (int i = 0; i < 16; i++) 
  {
    digitalWrite(pin_IR, HIGH);
    delayMicroseconds(11);
    digitalWrite(pin_IR, LOW);
    delayMicroseconds(11);
  }
}

void loop() {
  if (!digitalRead(pin_taster))   //Ist der Taster gedrückt worden?
  {
    CanonAusloesen(false);        //Löse die Kamera aus
    delay(500);                   //Warte eine halbe Sekunde ab.
  }
}

