#include <Process.h>

Process p;
int bildnummer = 1;  //Welche Nummer hat das zu machende Bild?
const long abstand_zwischen_bildern = 2; //Mache alle zehn Sekunden ein Bild

void setup() {
  Bridge.begin();     //Übertragung der Daten zu Linux
  Serial.begin(9600); //Übertragung (über USB) zum PC
  //Erstelle ein Verzeichniss für die Bilder
  p.runShellCommand("mkdir /mnt/sda1/Zeitraffer");
  bildnummer = hoechste_Bildnummer() + 1;
  Serial.print("Starte bei Bildnummer ");
  Serial.println(bildnummer);
}

void loop() {
  delay(abstand_zwischen_bildern * 1000L);
  bild_machen();
}

void bild_machen() {
  String kommando = "fswebcam -r 352x288  -F 2"
    " -S 3 --jpeg -1 --no-banner  /mnt/sda1/Zeitraffer/";
  kommando += bildname_generieren();
  Serial.println(kommando);
  p.runShellCommand(kommando);
  bildnummer++;
}

String bildname_generieren() {
  String bildname = "img";
  
  //Damit alle Bildnummer 4 Stellen haben,
  //werden noch führende Nullen eingefügt.
  if (bildnummer < 1000) bildname += "0";
  if (bildnummer <  100) bildname += "0";
  if (bildnummer <   10) bildname += "0";
  
  bildname += String(bildnummer);
  bildname += ".jpg";
  return bildname;
}

int hoechste_Bildnummer() {
  p.runShellCommand("ls /mnt/sda1/Zeitraffer/");
  String dateiname = "";
  int hoechste_nummer = 0;

  while (p.available()) {
    char c = p.read(); //Lese ein einzelnes Zeichen
    if (c == '\0' || c == '\n') { //Analysiere den Dateinamen
      if (dateiname.startsWith("img")) {
        //Extrahiere die Nummer im Dateinamen
        int nummer = dateiname.substring(3, 7).toInt();
        //Ist die gefundene Nummer die bisher höchste?
        hoechste_nummer = max(hoechste_nummer, nummer);
      }
      dateiname = "";
    } else {
      //Füge das Zeichen zum Dateinamen hinzu
      dateiname += c;
    }
  }
  return hoechste_nummer;
}



