#include <avr/sleep.h>
#include <avr/power.h>
#include <avr/wdt.h>


const int PIN_IRLED = 3;
const byte sensor_ID = 0x12;
void setup() {

  Serial.begin(9600);

  pinMode(PIN_IRLED, OUTPUT);
  digitalWrite(PIN_IRLED, HIGH);
  pinMode(13, OUTPUT);
  
  //Stelle Timer2 auf eine Frequenz von ~36KHz
  TCCR2A = B01100011;
  TCCR2B = B00001001;
  OCR2A = 25;
  OCR2B = 7;
  
  //Bereite den Watchdog-Timer vor
  MCUSR &= ~(1<<WDRF);
  WDTCSR |= (1<<WDCE) | (1<<WDE);
  WDTCSR = B01100001;
  
  /*//benutze die PullUps
  for(int i = 0; i < 13; i++)
    digitalWrite(i, HIGH);
  digitalWrite(A0, HIGH);
  digitalWrite(A1, HIGH);
  digitalWrite(A2, HIGH);
  digitalWrite(A3, HIGH);
  digitalWrite(A4, HIGH);
  digitalWrite(A5, HIGH);
  */
  ACSR |= B10000000;
}

void loop() {
  digitalWrite(13, HIGH);
  for (int i = 0; i < 1; i++) {
    //sende_IR_Code(0xFF, 8);
    int test = 12;
    uebertrage_Messwert(test);
    delay(50);
  }
  delay(500); 
  digitalWrite(13, LOW);
  for(int i = 0; i < 1;i++)
    schlafe();
}

void uebertrage_Messwert(int messwert) {
  long nachricht = 0;
  nachricht |= messwert & 0xffff;
  nachricht |= (long)sensor_ID << 16;

  for (int i = 0; i < 3; i++) {
    sende_IR_Code(nachricht, 24);
    delay(114);
  }
}

int messe_Temperatur() {
  return 0xFFFF;
}

void schlafe() {  
  
  
  ADCSRA &= B01111111;//schalte den ADC aus
  ADMUX &= B10111111;//Schalte die Interne Spannungsreferenz aus
  
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);  
  sleep_enable(); 
  MCUCR |= B01100000; //Schalte den BOD aus
  MCUCR |= B01000000;
  MCUCR &= B11011111;
  sleep_mode();
  
  sleep_disable();
  ADCSRA |= B10000000;//schalte den ADC ein
  ADMUX |= B01000000;//Schalte die interne Spannugnsreferenz ein
}

const int tHalfBit = 90;

void sende_IR_Code(unsigned long value, byte bitLength) {

  for (int i = 0; i < 2; i++) {
    pinMode(PIN_IRLED, INPUT); //IR ausschalten
    delayMicroseconds(tHalfBit);
    pinMode(PIN_IRLED, OUTPUT); //IR einschalten
    delayMicroseconds(tHalfBit);
  }
  for (int i = bitLength - 1; i >= 0; i--) {
    if ((value >> i) % 2 == 1) {
      pinMode(PIN_IRLED, INPUT); //IR ausschalten
      delayMicroseconds(tHalfBit);
      pinMode(PIN_IRLED, OUTPUT); //IR einschalten
      delayMicroseconds(tHalfBit);
    } else {
      pinMode(PIN_IRLED, OUTPUT); //IR einschalten
      delayMicroseconds(tHalfBit);
      pinMode(PIN_IRLED, INPUT); //IR ausschalten
      delayMicroseconds(tHalfBit);
    }
  }
  pinMode(PIN_IRLED, INPUT); //IR ausschalten
}
