#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# Robotik mit dem Raspberry Pi
# E.F.Engelhardt, Franzis Verlag, 2014
# -----------------------------------------------------------------------
# Bibliothek fuer PIUSV i2c-Schnittstelle
# 
# piusv.py
import i2c_lib
import time
from time import *
# USV Addresse PIUSV
I2C_USV_ADDRESS = 0x18
# -----------------------------------------------------------------------
# USV-Befehle
USV_STATUS = 0x00
USV_VERSION = 0x01
USV_SHUTDOWN = 0x10
# -----------------------------------------------------------------------
USV_SHUTDOWN_TIME=10 # in seconds
# -----------------------------------------------------------------------
class usv:
 #init usv
 def __init__(self):
  self.usv_device = i2c_lib.i2c_device(I2C_USV_ADDRESS)
  sleep(.2)

# read status
 def read_status(self):
  if self.usv_device.read_data(USV_STATUS) == 1:
    return "PRI_POW"
  elif self.usv_device.read_data(USV_STATUS) == 2:
    return "SEC_POW"
  elif self.usv_device.read_data(USV_STATUS) == 4:
    return "BAT_LOW"
  elif self.usv_device.read_data(USV_STATUS) == 5:
    return "PRI_POW  BAT_LOW"
  elif self.usv_device.read_data(USV_STATUS) == 6:
    return "SEC_POW  BAT_LOW"
  return hex(self.usv_device.read_data(USV_STATUS))

# ------------------------------------------------------------------------------------- 

