// -----------------------------------------------
#include <SPI.h>
#include <Ethernet.h>
#include <string.h>
#define HTTP_PORT 80

#define AOPENER_DEBUG
#define WMMIELE

byte mac[] = {0xDE, 0xAD, 0x00, 0x00, 0xAF, 0xFE};
IPAddress dnServer(192, 168, 123, 199);
IPAddress gateway(192, 168, 123, 199);
IPAddress subnet(255, 255, 255, 0);
IPAddress ip(192, 168, 123, 36);

#if ( defined(WMMIELE))
char *wmMIELE = "192.168.123.33"; // IP Gateway
String currentLine = "";            // string for incoming serial data
String currInformation = "";
boolean readingInformation = false;       // is reading?
String currAction = "";
boolean readingActions = false;       // is reading?
const int requestInterval = 600000; // milliseconds delay between requests
char value[128] = {0};
boolean xmlLinkOK, xmlLinkReady = false;
#endif
EthernetClient client;
// ----------------------------------------------------------------------------------------------------
void setup(){
  Ethernet.begin(mac, ip);
  Serial.begin(115000);
  delay(1000);
  xmlLinkOK = false;
}
// ----------------------------------------------------------------------------------------------------
String getMieleXMLLink() { // (char xmlAdresse, size_t xmlAdresse_sz){
  String xmlLink = "";
  char xml[1024] = {0};
  if (client.available()) {
    char inChar = client.read();
    sprintf(xml, "%s%c", xml, inChar);
    currentLine += inChar;
    // Falls newline-Zeichen, dann diese entfernen
    if (inChar == '\n') {
      currentLine = "";
    }
    if (currentLine.endsWith("<actions>")) {
      readingActions = true;
    }
    else if (readingActions) {
      if (!currentLine.endsWith("</actions>")) { //'</actions>' ist Ende der Suchfolge
        currAction += inChar;
      }
      else { // tzui
        readingActions = false;
        String justAction = currAction.substring(0, currAction.length() - 12);
        // DEBUG                Serial.println(justAction);
        // Splitten des Strings justAction
        String firstStr = "<action name=\"";
        int firstSpaceIndex = justAction.indexOf(firstStr) + firstStr.length();
        int secondSpaceIndex = justAction.indexOf("\" ", firstSpaceIndex + 1);
        String firstVal = justAction.substring(firstSpaceIndex, secondSpaceIndex); // Details
        String secondStr = " URL=\"";
        secondSpaceIndex += secondStr.length();
        String thirdStr = "\"/>";
        int thirdSpaceIndex = justAction.indexOf(thirdStr);
        String secondVal = justAction.substring(secondSpaceIndex + 1, thirdSpaceIndex); // Details = XML-Link
        secondVal.replace("&amp;", "&");
        secondVal.replace("http://", "");
        secondVal.replace("192.", "");
        secondVal.replace("168.", "");
        secondVal.replace("123.", "");
        secondVal.replace("33:80", "");
        xmlLink += secondVal;
        if (xmlLink.length() < 10) {
          xmlLink = "";
        }
        // Reset for next Action
        currAction = "";
        return xmlLink;
      } // else tzui
    }  // else if (readingActions)
  } // if (client.available())
}
// ----------------------------------------------------------------------------------------------------
bool connectMieleXML(char* xmlLink) {
  String xmlmessage = "";
//DEBUG  Serial.print("Verbindungsaufbau...");
  xmlmessage += "GET ";
  xmlmessage += xmlLink;
  xmlmessage += " HTTP/1.0";
  client.stop();
  if (client.connect(wmMIELE, 80)) {
//DEBUG    Serial.print("...verbunden...\nVerbindung mit Adresse: ");
    client.println(xmlmessage);
//DEBUG    Serial.println(xmlmessage);
    client.println();
    return true;
  } else {
//DEBUG    Serial.println("[connectMieleXML] Verbindung fehlgeschlagen!");
    return false;
  }
  return false;
}
// ----------------------------------------------------------------------------------------------------
void getMieleXMLStatus(struct mieleWM *wm) {
  String retString= "";
  bool xmlWMOK = false;
  while (xmlWMOK == false) {
    if (xmlLinkOK == false) {
      if (connectMieleXML("/homebus") == true) {
        xmlLinkOK = true;
      }
    }
    if (xmlLinkOK == true) {
      String answer = getMieleXMLLink();
      if (answer == NULL) {
//DEBUG        Serial.print("\nXML-Link - keine Antwort...\n");
      }
      else {
//DEBUG        Serial.print("\nXML-Link gefunden: ");
        answer.toCharArray(value, sizeof(value));
        if (connectMieleXML(value) == true) {
          xmlLinkReady = true;
        }
      }
    }
    if (xmlLinkReady == true) {
      //DEBUG        Serial.println(value);
      //DEBUG        Serial.print("\n");
      if (client.connected()) {
        char xml[1024] = {0};
        while (client.available()) {
          //DEBUG Serial.println("Verbunden.. -  hole Status-Informationen");
          char inChar = client.read();
          sprintf(xml, "%s%c", xml, inChar);
          //    Serial.println(xml);
          currentLine += inChar;
          if (inChar == '\n') {
            currentLine = "";
          }

          if (currentLine.endsWith("<information>")) {
            readingInformation = true;
          }
          else if (readingInformation) {
            if (!currentLine.endsWith("</information>")) { //'>' is our ending character
              currInformation += inChar;
            }
            else {
              readingInformation = false;
              String justInformation = currInformation.substring(0, currInformation.length() - 13);
              // DEBUG

//DEBUG              Serial.print("\nDatenstrom : ");
//DEBUG              Serial.print(justInformation);
              Serial.print("\n\n");

              // ENDE DEBUG
              String firstStr = "<key name=\"";
              int firstSpaceIndex = justInformation.indexOf(firstStr) + firstStr.length(); // 11 Zeichen lang
              int secondSpaceIndex = justInformation.indexOf("\" ", firstSpaceIndex + 1);
              String firstVal = justInformation.substring(firstSpaceIndex, secondSpaceIndex); // Bezeichnung
              String secondStr = " value=\"";
              secondSpaceIndex += secondStr.length();
              String thirdStr = "\" />";
              int thirdSpaceIndex = justInformation.indexOf(thirdStr);
              String secondVal = justInformation.substring(secondSpaceIndex + 1, thirdSpaceIndex); // Wert zu firstVal
              wm->bezeichnung = justInformation.substring(secondSpaceIndex + 1, thirdSpaceIndex); // Wert zu firstVal
              //-----------------------------
              // Gertestatus
              // nchster key name = firstStr
              int fourthSpaceIndex = justInformation.indexOf(firstStr) + thirdSpaceIndex + firstStr.length() + 4; // vier leerzeichn
              int fifthSpaceIndex = justInformation.indexOf(secondStr, fourthSpaceIndex) - 1;
              String thirdVal = justInformation.substring(fourthSpaceIndex, fifthSpaceIndex); // 2. Bezeichnung
              // start Value bei fifthSpaceIndex + secondStr.length()
              fifthSpaceIndex += secondStr.length();
              int sixSpaceIndex = justInformation.indexOf(thirdStr, fifthSpaceIndex + 1);
              String fourthVal = justInformation.substring(fifthSpaceIndex + 1, sixSpaceIndex); // Wert zu thirdVal
              wm->wmstatus = justInformation.substring(fifthSpaceIndex + 1, sixSpaceIndex); // Wert zu thirdVal
              //-----------------------------
              // Programm
              int sevenSpaceIndex = justInformation.indexOf(firstStr, sixSpaceIndex + 1) + firstStr.length() - 1;
              int eightSpaceIndex = justInformation.indexOf(secondStr, sevenSpaceIndex) - 1;
              String fifthVal = justInformation.substring(sevenSpaceIndex + 1, eightSpaceIndex);
              eightSpaceIndex += secondStr.length();
              int nineSpaceIndex = justInformation.indexOf(thirdStr, eightSpaceIndex + 1);
              String sixthVal = justInformation.substring(eightSpaceIndex + 1, nineSpaceIndex); // Wert zu fifthVal
              wm->programm = justInformation.substring(eightSpaceIndex + 1, nineSpaceIndex);
              //-----------------------------
              // Phase
              int tenSpaceIndex = justInformation.indexOf(firstStr, nineSpaceIndex + 1) + firstStr.length() - 1;
              int elevenSpaceIndex = justInformation.indexOf(secondStr, tenSpaceIndex) - 1;
              String seventhVal = justInformation.substring(tenSpaceIndex + 1, elevenSpaceIndex);
              elevenSpaceIndex += secondStr.length();
              int twelveSpaceIndex = justInformation.indexOf(thirdStr, elevenSpaceIndex + 1);
              String eightVal = justInformation.substring(elevenSpaceIndex + 1, twelveSpaceIndex); // Wert zu seventhVal
              wm->phase = justInformation.substring(elevenSpaceIndex + 1, twelveSpaceIndex); // Wert zu seventhVal
              //-----------------------------
              // Startzeit
              int thirteenthSpaceIndex = justInformation.indexOf(firstStr, twelveSpaceIndex + 1) + firstStr.length() - 1;
              int fourteenthSpaceIndex = justInformation.indexOf(secondStr, thirteenthSpaceIndex) - 1;
              String ninthVal = justInformation.substring(thirteenthSpaceIndex + 1, fourteenthSpaceIndex);
              fourteenthSpaceIndex += secondStr.length();
              int fiveteenthSpaceIndex = justInformation.indexOf(thirdStr, fourteenthSpaceIndex + 1);
              String tenthVal = justInformation.substring(fourteenthSpaceIndex + 1, fiveteenthSpaceIndex); // Wert zu ninthVal
              wm->startzeit = justInformation.substring(fourteenthSpaceIndex + 1, fiveteenthSpaceIndex); // Wert zu ninthVal
              //-----------------------------
              // Dauer
              int sixteenthSpaceIndex = justInformation.indexOf(firstStr, fiveteenthSpaceIndex + 1) + firstStr.length() - 1;
              int seventeenthSpaceIndex = justInformation.indexOf(secondStr, sixteenthSpaceIndex) - 1;
              String eleventhVal = justInformation.substring(sixteenthSpaceIndex + 1, seventeenthSpaceIndex);
              seventeenthSpaceIndex += secondStr.length();
              int eighteenthSpaceIndex = justInformation.indexOf(thirdStr, seventeenthSpaceIndex + 1);
              String twelfthVal = justInformation.substring(seventeenthSpaceIndex + 1, eighteenthSpaceIndex); // Wert zu eleventhVal
              wm->dauer = justInformation.substring(seventeenthSpaceIndex + 1, eighteenthSpaceIndex); // Wert zu eleventhVal
              //-----------------------------
              // Endzeit
              int nineteenthSpaceIndex = justInformation.indexOf(firstStr, eighteenthSpaceIndex + 1) + firstStr.length() - 1;
              int twentiethSpaceIndex = justInformation.indexOf(secondStr, nineteenthSpaceIndex) - 1;
              String thirteenthVal = justInformation.substring(nineteenthSpaceIndex + 1, twentiethSpaceIndex);
              twentiethSpaceIndex += secondStr.length();
              int twentyfirstSpaceIndex = justInformation.indexOf(thirdStr, twentiethSpaceIndex + 1);
              String fourteenthVal = justInformation.substring(twentiethSpaceIndex + 1, twentyfirstSpaceIndex); // Wert zu thirteenthVal
              wm->endzeit = justInformation.substring(twentiethSpaceIndex + 1, twentyfirstSpaceIndex); // Wert zu thirteenthVal
              // Reset for next reading
              currInformation = "";
              // raus aus while
              xmlWMOK = true;
              return;
            }
          }
          if (!client.connected()) {
//DEBUG            Serial.println();
//DEBUG            Serial.println("[getMieleXMLStatus] Keine Verbindung!");
            client.stop();
            for (;;)
              ;
          }
        }
      }
    } else {
//DEBUG      Serial.println("xmlLinkReady == false -> Kein XML-Link gefunden?");
    }
  } // of while
}
// ----------------------------------------------------------------------------------------------------
void loop() {
  miele_struct wm;
  /*
  0 - leer
  1 bezeichnung
  2 wmstatus
  3 programm
  4 phase
  5 startzeit
  6 dauer
  7 endzeit
  */
  getMieleXMLStatus(&wm);
  
  if (wm.bezeichnung != "" && wm.wmstatus != "Aus" ) {
    Serial.print("\nWaschmaschine gefunden: \n\n");
    Serial.print("Name: ");
    Serial.println(wm.bezeichnung);    
    Serial.print("Status: ");
    Serial.println( wm.wmstatus);
    Serial.print("Eingestelltes Programm: ");
    Serial.println(wm.programm);
    Serial.print("Phase: ");
    Serial.println(wm.phase);
    Serial.print("Startzeit: ");
    Serial.println(wm.startzeit);
    Serial.print("Restzeit in Minuten: ");
    Serial.println(wm.dauer);
    Serial.print("Ende des Waschgangs: ");
    Serial.println(wm.endzeit);
    Serial.print("\n\n");  
    }
    else {
      Serial.print("Aktuelle Zeit: ");
//      Serial.println(getActTime());
      Serial.print("\nWaschmaschine ist ausgeschaltet. \n\n");
      }
    delay(requestInterval); 
}
// ------------------------------------------------------------------------------------------
