// -----------------------------------------------
// fuer Ethernet Shield
// nimmt Interrupts 18/19
#include <EEPROM.h>
#include <SPI.h>
#include <Ethernet.h>
#include <string.h>
// -----------------------------------------------
// SDfat Library -> https://github.com/greiman/SdFat
// Herunterladen und nachinstallieren ueber -> Sketch -> Include Library -> Add ZIP Library -> SdFat-master.zip
#include <SdFat.h>
SdFat SD;
SdFile ekeyFile;
//
#define HTTP_PORT 80
// #define AOPENER_DEBUG
#define WMMIELE

byte mac[] = {0xAE, 0xAD, 0x00, 0x00, 0xAF, 0xFE};
IPAddress dnServer(192, 168, 123, 199);
IPAddress gateway(192, 168, 123, 199);
IPAddress subnet(255, 255, 255, 0);
IPAddress ip(192, 168, 123, 135);

EthernetClient client;
// -----------------------------------------------
// SD-Karten Slot auf Ethernet Shield
const int SD_PIN = 4; // Pin zur Kommunikation mit SD Card.
const int ETH_PIN = 10; // Pin zur Kommunikation mit ETHERNET
// const int ETH_PIN = 53; // Pin zur Kommunikation mit ETHERNET 
// -----------------------------------------------
File myFile;
#define EKEYFILE "ekeyfinger.csv" // Dateiname fuer Daten
bool SDOK = false;

#if ( defined(WMMIELE))
char *wmMIELE = "192.168.123.33"; // IP fuer Miele Gateway
char value[128] = {0};
String currentLine = "";            // String serielle Daten
String currInformation, currAction = "";
String xmlAnswer = "";
boolean readingActions, readingInformation = false;     
const int requestInterval = 600000; // milliseconds delay between requests
boolean xmlLinkOK, xmlLinkReady, xmlLoopOK = false;
//Datentyp für mieleWM dannn in Header Datei
/*
typedef struct mieleWM {
  String bezeichnung = "";
  String wmstatus = "";
  String programm = "";
  String phase = "";
  String startzeit = "";
  String dauer = "";
  String endzeit = "";
} miele_struct;
*/
int j = 0;
#include "mieleWM.h"
#endif

// ----------------------------------------------------------------------------------------------------
// EPROM-Beispiele von:
// http://playground.arduino.cc/Code/EepromUtil
// ----------------------------------------------------------------------------------------------------
// Absolute min and max eeprom addresses. Actual values are hardware-dependent.
// These values can be changed e.g. to protect eeprom cells outside this range.
const int EEPROM_MIN_ADDR = 0;
const int EEPROM_MAX_ADDR = 511;
// ----------------------------------------------------------------------------------------------------
const int BUFSIZE = 80;  // 80 ist ca. Laenge des XML-Strings
char buf[BUFSIZE];
// ---------------------------------------------------------------------------------------------
void setupSDread() {
  digitalWrite(ETH_PIN, HIGH);   // ETH abschalten
  digitalWrite(SD_PIN, LOW);   // SD Karte einschalten
  if (!SD.begin(SD_PIN, SPI_HALF_SPEED)) {
    SD.initErrorHalt();
  }
  // open the file for write at end like the Native SD library
  if (!ekeyFile.open(EKEYFILE, O_READ)) {
    SD.errorHalt("[setupSDread] Fehler beim Oeffnen...");
  }
#ifdef AOPENER_DEBUG
  Serial.println("\n[setupSDread] Oeffne Datei <ekeyfinger.csv> fuer Webtransfer...");
  Serial.println("\n[setupSDread] ETH AUS");
  Serial.println("\n[setupSDread] SD EIN");
#endif
  return;
}
// ---------------------------------------------------------------------------------------------
void setupSDwrite() {
  digitalWrite(ETH_PIN, HIGH);   // ETH abschalten
  digitalWrite(SD_PIN, LOW);   // SD Karte einschalten
  if (!SD.begin(SD_PIN, SPI_HALF_SPEED)) {
    SD.initErrorHalt();
  }
  // open the file for write at end like the Native SD library
  if (!ekeyFile.open(EKEYFILE, O_RDWR | O_CREAT | O_AT_END)) {
    SD.errorHalt("\n[setupSDwrite] Fehler beim Oeffnen...");
  }
#ifdef AOPENER_DEBUG
  Serial.println("\n[setupSDwrite] Open ekeyfinger.csv zum Schreiben...");
  Serial.println("\n[setupSDwrite] ETH AUS");
  Serial.println("\n[setupSDwrite] SD EIN");
#endif
}
// ---------------------------------------------------------------------------------------------
void setSDonReadETHoff() {
  setSDonETHoff();
#ifdef AOPENER_DEBUG
  Serial.println("\n[setSDonReadETHoff] SD READ");
#endif
  setupSDread();
  return;
}
// ---------------------------------------------------------------------------------------------
void setSDonWriteETHoff() {
  setSDonETHoff();
  //  Serial.println("\n[setSDonWriteETHoff] SD WRITE");
  setupSDwrite();
  return;
}
// ---------------------------------------------------------------------------------------------
void setSDonETHoff() {
  digitalWrite(ETH_PIN, HIGH);   // ETH abschalten
  digitalWrite(SD_PIN, LOW);   // SD Karte einschalten
#ifdef AOPENER_DEBUG
  Serial.println("\n[setSDonETHoff] ETH AUS");
  Serial.println("\n[setSDonETHoff] SD EIN");
#endif
  return;
}
// ---------------------------------------------------------------------------------------------
void setSDoffETHon() {
  digitalWrite(ETH_PIN, LOW);   // ETH einschalten
  digitalWrite(SD_PIN, HIGH);   // SD Karte ausschalten
#ifdef AOPENER_DEBUG
  Serial.println("\n[setSDoffETHon] ETH EIN");
  Serial.println("\n[setSDoffETHon] SD AUS");
#endif
  return;
}
// ----------------------------------------------------------------------------------------------------
// EPROM-Beispiele von:
// http://playground.arduino.cc/Code/EepromUtil
// Returns true if the address is between the
// minimum and maximum allowed values, false otherwise.
//
// This function is used by the other, higher-level functions
// to prevent bugs and runtime errors due to invalid addresses.
boolean eeprom_is_addr_ok(int addr) {
  return ((addr >= EEPROM_MIN_ADDR) && (addr <= EEPROM_MAX_ADDR));
}
// Writes a sequence of bytes to eeprom starting at the specified address.
// Returns true if the whole array is successfully written.
// Returns false if the start or end addresses aren't between
// the minimum and maximum allowed values.
// When returning false, nothing gets written to eeprom.
boolean eeprom_write_bytes(int startAddr, const byte* array, int numBytes) {
  // counter
  int i;
  // both first byte and last byte addresses must fall within
  // the allowed range
  if (!eeprom_is_addr_ok(startAddr) || !eeprom_is_addr_ok(startAddr + numBytes)) {
    return false;
  }
  for (i = 0; i < numBytes; i++) {
    EEPROM.write(startAddr + i, array[i]);
  }
  return true;
}
//
// Initialize eeprom memory with
// the specified byte.
// Default value is 0xFF.
//
void eeprom_erase_all(byte b = 0xFF) {
  int i;

  for (i = EEPROM_MIN_ADDR; i <= EEPROM_MAX_ADDR; i++) {
    EEPROM.write(i, b);
  }
}
// ----------------------------------------------------------------------------------------------------
// Writes a string starting at the specified address.
// Returns true if the whole string is successfully written.
// Returns false if the address of one or more bytes fall outside the allowed range.
// If false is returned, nothing gets written to the eeprom.
boolean eeprom_write_string(int addr, const char* string) {
  int numBytes; // actual number of bytes to be written
  //write the string contents plus the string terminator byte (0x00)
  numBytes = strlen(string) + 1;
  return eeprom_write_bytes(addr, (const byte*)string, numBytes);
}
// ----------------------------------------------------------------------------------------------------
// Reads a string starting from the specified address.
// Returns true if at least one byte (even only the string terminator one) is read.
// Returns false if the start address falls outside the allowed range or declare buffer size is zero.
//
// The reading might stop for several reasons:
// - no more space in the provided buffer
// - last eeprom address reached
// - string terminator byte (0x00) encountered.
boolean eeprom_read_string(int addr, char* buffer, int bufSize) {
  byte ch; // byte read from eeprom
  int bytesRead; // number of bytes read so far
  if (!eeprom_is_addr_ok(addr)) { // check start address
    return false;
  }

  if (bufSize == 0) { // how can we store bytes in an empty buffer ?
    return false;
  }
  // is there is room for the string terminator only, no reason to go further
  if (bufSize == 1) {
    buffer[0] = 0;
    return true;
  }
  bytesRead = 0; // initialize byte counter
  ch = EEPROM.read(addr + bytesRead); // read next byte from eeprom
  buffer[bytesRead] = ch; // store it into the user buffer
  bytesRead++; // increment byte counter

  // stop conditions:
  // - the character just read is the string terminator one (0x00)
  // - we have filled the user buffer
  // - we have reached the last eeprom address
  while ( (ch != 0x00) && (bytesRead < bufSize) && ((addr + bytesRead) <= EEPROM_MAX_ADDR) ) {
    // if no stop condition is met, read the next byte from eeprom
    ch = EEPROM.read(addr + bytesRead);
    buffer[bytesRead] = ch; // store it into the user buffer
    bytesRead++; // increment byte counter
  }

  // make sure the user buffer has a string terminator, (0x00) as its last byte
  if ((ch != 0x00) && (bytesRead >= 1)) {
    buffer[bytesRead - 1] = 0;
  }
  return true;
}
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
bool connectMieleXML(char* xmlLink) {
  String xmlmessage = "";
  //DEBUG    Serial.print("\n[connectMieleXML] Verbindungsversuch mit Kommando...: ");
  xmlmessage += "GET ";
  xmlmessage += xmlLink;
  xmlmessage += " HTTP/1.0";
  client.stop();
  // DEBUG   Serial.println(xmlmessage);
  if (client.connect(wmMIELE, HTTP_PORT)) {
    //DEBUG            Serial.print("...verbunden...\n[connectMieleXML] Verbindung mit Adresse: ");
    client.println(xmlmessage);
    //DEBUG            Serial.println(xmlmessage);
    client.println();
    delay(2000);
    return true;
  } else {
    //DEBUG            Serial.println("[connectMieleXML] Verbindung fehlgeschlagen!");
    return false;
  }
  return false;
}
#endif
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
String getMieleXMLLink() { // (char xmlAdresse, size_t xmlAdresse_sz){
  String xmlLink = "";
  char xml[1024] = {0};
  if (client.available()) {
    char inChar = client.read();
    sprintf(xml, "%s%c", xml, inChar);
    currentLine += inChar;
    // if you get a newline, clear the line:
    if (inChar == '\n') {
      currentLine = "";
    }
    if (currentLine.endsWith("<actions>")) {
      readingActions = true;
    }
    else if (readingActions) {
      if (!currentLine.endsWith("</actions>")) { //'>' is our ending character
        currAction += inChar;
      }
      else { // tzui
        readingActions = false;
        String justAction = currAction.substring(0, currAction.length() - 12);
        // DEBUG                        Serial.println(justAction);
        String firstStr = "<action name=\"";
        int firstSpaceIndex = justAction.indexOf(firstStr) + firstStr.length();
        int secondSpaceIndex = justAction.indexOf("\" ", firstSpaceIndex + 1);
        String firstVal = justAction.substring(firstSpaceIndex, secondSpaceIndex); // Details
        String secondStr = " URL=\"";
        secondSpaceIndex += secondStr.length();
        String thirdStr = "\"/>";
        int thirdSpaceIndex = justAction.indexOf(thirdStr);
        String secondVal = justAction.substring(secondSpaceIndex + 1, thirdSpaceIndex); // Details = XML-Link
        secondVal.replace("&amp;", "&");
        secondVal.replace("http://", "");
        secondVal.replace("192.", "");
        secondVal.replace("168.", "");
        secondVal.replace("123.", "");
        secondVal.replace("33:80", "");
        xmlLink += secondVal;
        if (xmlLink.length() < 10) {
          xmlLink = "";
        }
        currAction = "";
        client.stop();
        return xmlLink;
      } // else tzui
    }  // else if (readingActions)
  } // if (client.available())
  else {
    // DEBUG
    Serial.println("[getMieleXMLLink] Keine Verbindung...");
  }
}
#endif
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
void saveXMLLinkEPROM() {
  bool xmlWMOK = false;
  while (xmlWMOK == false) {
    if (xmlLinkOK == false) {
      if (connectMieleXML("/homebus") == true) {
        xmlLinkOK = true;
      }
    }
    if (xmlLinkOK == true) {
      String answer = getMieleXMLLink();
      if (answer == NULL) {
        //DEBUG        Serial.print("\nXML-Link - keine Antwort...\n");
      }
      else {
        //DEBUG        Serial.print("\nXML-Link gefunden: ");
        answer.toCharArray(value, sizeof(value));
        if (connectMieleXML(value) == true) {
          xmlLinkReady = true;
        }
      }
    }
    if (xmlLinkReady == true) {
      // SPEICHERN IN EPROM in Adresse 0
      strcpy(buf, value);
      eeprom_write_string(0, buf);
      //DEBUG
      Serial.print("Saving string : ");
      Serial.print(value);
      Serial.println(" to address 0");
      delay(2000);
      xmlWMOK = true;
    }
  } // while
}
#endif
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
String getXMLLinkEPROM() {
  // Adresse 0
  eeprom_read_string(0, buf, BUFSIZE);
  // DEBUG
  //  Serial.print("Reading string from address 0: ");
  //  Serial.println(buf);
  return buf;
}
#endif
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
String getLink() {
  String xmlLink = getXMLLinkEPROM();
  xmlLink.toCharArray(value, sizeof(value));
  if (strstr(value, "homebus"))  {
    //     Serial.println("XML-Link ist in EPROM vorhanden!");
  }
  else {
    // kein Link im Eprom
    //     Serial.println("XML-Link von Statusseite laden!");
    saveXMLLinkEPROM();
    xmlLink = getXMLLinkEPROM();
  }
  return xmlLink;
}
#endif
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
void getXMLLink() {
  bool xmlWMOK = false;
  while (xmlWMOK == false) {
    if (xmlLinkOK == false) {
      if (connectMieleXML("/homebus") == true) {
        xmlLinkOK = true;
      }
    }
    if (xmlLinkOK == true) {
      String answer = getMieleXMLLink();
      if (answer == NULL) {
        //DEBUG        Serial.print("\nXML-Link - keine Antwort...\n");
      }
      else {
        //DEBUG        
        Serial.print("\nXML-Link gefunden: ");
        answer.toCharArray(value, sizeof(value));
        if (connectMieleXML(value) == true) {
          xmlLinkReady = true;
        }
      }
    }
    if (xmlLinkReady == true) {
      //DEBUG
      Serial.println(value);
      delay(2000);
      xmlWMOK = true;
    }
  } // while
}
#endif
// ----------------------------------------------------------------------------------------------------
void setup() {
  //  eeprom_erase_all();
  Serial.begin(115000);
  pinMode(ETH_PIN, OUTPUT);
  pinMode(SD_PIN, OUTPUT);
  //**
  //digitalWrite(ETH_PIN, HIGH); // TEST 53
  //**
  setSDonWriteETHoff(); // Schreibend-Modus einschalten
  setSDoffETHon();   // ETH einschalten
  Ethernet.begin(mac, ip, dnServer, gateway, subnet);
  Serial.print("setup ok, IP: ");
  Serial.println(Ethernet.localIP());
  xmlLinkOK = false;
  //  getLink();
  Serial.println("Setup done");
}
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
void getWMInfo(struct mieleWM *wm) {
  bool xmlWMOK, xmlConnectReady = false;
  String answer = getLink();
  if (answer == NULL) {
    // DEBUG     Serial.print("\nXML-Link - keine Antwort...\n");
  }
  else {
    // DEBUG         Serial.print("\nXML-Link - gefunden...\n");
    // DEBUG         Serial.println(answer);
    xmlLinkReady = true;
  }
  if (xmlLinkReady == true) {
    // DEBUG     Serial.print("\nVerbindung zu Miele-Server...");
    while (xmlWMOK == false) {
      if (connectMieleXML(value) == true) {
        xmlConnectReady = true;
        // DEBUG         Serial.println("..erfolgreich");
      } else {
        // DEBUG         Serial.println("..nicht erfolgreich");
      }
      //
      if ((xmlConnectReady = true) && client.connected()) {
        // #######################
        char xml[1024] = {0};
        while (client.available()) {
          //DEBUG           Serial.println("Verbunden.. -  hole Status-Informationen");
          char inChar = client.read();
          sprintf(xml, "%s%c", xml, inChar);
        // DEBUG           Serial.println(xml);
          currentLine += inChar;
          if (inChar == '\n') {
            currentLine = "";
          }

          if (currentLine.endsWith("<information>")) {
            readingInformation = true;
          }
          else if (readingInformation) {
            if (!currentLine.endsWith("</information>")) { //'>' is our ending character
              currInformation += inChar;
            }
            else {
              readingInformation = false;
              String justInformation = currInformation.substring(0, currInformation.length() - 13);
              //DEBUG              Serial.print("\nDatenstrom : ");
              //DEBUG              Serial.print(justInformation);               Serial.print("\n\n");
              String firstStr = "<key name=\"";
              int firstSpaceIndex = justInformation.indexOf(firstStr) + firstStr.length(); // 11 Zeichen lang
              int secondSpaceIndex = justInformation.indexOf("\" ", firstSpaceIndex + 1);
              String firstVal = justInformation.substring(firstSpaceIndex, secondSpaceIndex); // Bezeichnung
              String secondStr = " value=\"";
              secondSpaceIndex += secondStr.length();
              String thirdStr = "\" />";
              int thirdSpaceIndex = justInformation.indexOf(thirdStr);
              String secondVal = justInformation.substring(secondSpaceIndex + 1, thirdSpaceIndex); // Wert zu firstVal
              wm->bezeichnung = justInformation.substring(secondSpaceIndex + 1, thirdSpaceIndex); // Wert zu firstVal
              //-----------------------------
              // Gerätestatus
              // nächster key name = firstStr
              int fourthSpaceIndex = justInformation.indexOf(firstStr) + thirdSpaceIndex + firstStr.length() + 4; // vier leerzeichn
              int fifthSpaceIndex = justInformation.indexOf(secondStr, fourthSpaceIndex) - 1;
              String thirdVal = justInformation.substring(fourthSpaceIndex, fifthSpaceIndex); // 2. Bezeichnung
              // start Value bei fifthSpaceIndex + secondStr.length()
              fifthSpaceIndex += secondStr.length();
              int sixSpaceIndex = justInformation.indexOf(thirdStr, fifthSpaceIndex + 1);
              String fourthVal = justInformation.substring(fifthSpaceIndex + 1, sixSpaceIndex); // Wert zu thirdVal
              wm->wmstatus = justInformation.substring(fifthSpaceIndex + 1, sixSpaceIndex); // Wert zu thirdVal
              //-----------------------------
              // Programm
              int sevenSpaceIndex = justInformation.indexOf(firstStr, sixSpaceIndex + 1) + firstStr.length() - 1;
              int eightSpaceIndex = justInformation.indexOf(secondStr, sevenSpaceIndex) - 1;
              String fifthVal = justInformation.substring(sevenSpaceIndex + 1, eightSpaceIndex);
              eightSpaceIndex += secondStr.length();
              int nineSpaceIndex = justInformation.indexOf(thirdStr, eightSpaceIndex + 1);
              String sixthVal = justInformation.substring(eightSpaceIndex + 1, nineSpaceIndex); // Wert zu fifthVal
              wm->programm = justInformation.substring(eightSpaceIndex + 1, nineSpaceIndex);
              //-----------------------------
              // Phase
              int tenSpaceIndex = justInformation.indexOf(firstStr, nineSpaceIndex + 1) + firstStr.length() - 1;
              int elevenSpaceIndex = justInformation.indexOf(secondStr, tenSpaceIndex) - 1;
              String seventhVal = justInformation.substring(tenSpaceIndex + 1, elevenSpaceIndex);
              elevenSpaceIndex += secondStr.length();
              int twelveSpaceIndex = justInformation.indexOf(thirdStr, elevenSpaceIndex + 1);
              String eightVal = justInformation.substring(elevenSpaceIndex + 1, twelveSpaceIndex); // Wert zu seventhVal
              wm->phase = justInformation.substring(elevenSpaceIndex + 1, twelveSpaceIndex); // Wert zu seventhVal
              //-----------------------------
              // Startzeit
              int thirteenthSpaceIndex = justInformation.indexOf(firstStr, twelveSpaceIndex + 1) + firstStr.length() - 1;
              int fourteenthSpaceIndex = justInformation.indexOf(secondStr, thirteenthSpaceIndex) - 1;
              String ninthVal = justInformation.substring(thirteenthSpaceIndex + 1, fourteenthSpaceIndex);
              fourteenthSpaceIndex += secondStr.length();
              int fiveteenthSpaceIndex = justInformation.indexOf(thirdStr, fourteenthSpaceIndex + 1);
              String tenthVal = justInformation.substring(fourteenthSpaceIndex + 1, fiveteenthSpaceIndex); // Wert zu ninthVal
              wm->startzeit = justInformation.substring(fourteenthSpaceIndex + 1, fiveteenthSpaceIndex); // Wert zu ninthVal
              //-----------------------------
              // Dauer
              int sixteenthSpaceIndex = justInformation.indexOf(firstStr, fiveteenthSpaceIndex + 1) + firstStr.length() - 1;
              int seventeenthSpaceIndex = justInformation.indexOf(secondStr, sixteenthSpaceIndex) - 1;
              String eleventhVal = justInformation.substring(sixteenthSpaceIndex + 1, seventeenthSpaceIndex);
              seventeenthSpaceIndex += secondStr.length();
              int eighteenthSpaceIndex = justInformation.indexOf(thirdStr, seventeenthSpaceIndex + 1);
              String twelfthVal = justInformation.substring(seventeenthSpaceIndex + 1, eighteenthSpaceIndex); // Wert zu eleventhVal
              wm->dauer = justInformation.substring(seventeenthSpaceIndex + 1, eighteenthSpaceIndex); // Wert zu eleventhVal
              //-----------------------------
              // Endzeit
              int nineteenthSpaceIndex = justInformation.indexOf(firstStr, eighteenthSpaceIndex + 1) + firstStr.length() - 1;
              int twentiethSpaceIndex = justInformation.indexOf(secondStr, nineteenthSpaceIndex) - 1;
              String thirteenthVal = justInformation.substring(nineteenthSpaceIndex + 1, twentiethSpaceIndex);
              twentiethSpaceIndex += secondStr.length();
              int twentyfirstSpaceIndex = justInformation.indexOf(thirdStr, twentiethSpaceIndex + 1);
              String fourteenthVal = justInformation.substring(twentiethSpaceIndex + 1, twentyfirstSpaceIndex); // Wert zu thirteenthVal
              wm->endzeit = justInformation.substring(twentiethSpaceIndex + 1, twentyfirstSpaceIndex); // Wert zu thirteenthVal
              // Reset for next reading
              currInformation = "";
              // raus aus while
              xmlWMOK = true;
              // TEST
              // client.stop();
              return;
            }
          }
          if (!client.connected()) {
            //DEBUG            Serial.println();
            //DEBUG            Serial.println("[getMieleXMLStatus] Keine Verbindung!");
            client.stop();
            for (;;)
              ;
          }
        }
        // ########################
      }
    }
  }
}
#endif
// ----------------------------------------------------------------------------------------------------
#if ( defined(WMMIELE))
void chkMIele(){
  miele_struct wm;
  /*
  0 - leer
  1 bezeichnung
  2 wmstatus
  3 programm
  4 phase
  5 startzeit
  6 dauer
  7 endzeit
  */
  getWMInfo(&wm);
  if (wm.bezeichnung != "" && wm.programm != "In Betrieb" ) {
//  if (wm.bezeichnung != "" && wm.programm == "In Betrieb" ) {  
    Serial.print("\nWaschmaschine gefunden: \n\n");
    Serial.print("Name: ");
    Serial.println( wm.bezeichnung);
    Serial.print("Status: ");
    Serial.println( wm.wmstatus);
    Serial.print("Eingestelltes Programm: ");
    Serial.println( wm.programm);
    Serial.print("Phase: ");
    Serial.println( wm.phase);
    Serial.print("Startzeit: ");
    Serial.println( wm.startzeit);
    Serial.print("Restzeit in Minuten: ");
    Serial.println( wm.dauer);
    Serial.print("Ende des Waschgangs: ");
    Serial.println( wm.endzeit);
    Serial.print("\n\n");
  }
  delay(requestInterval);
}
#endif
// ----------------------------------------------------------------------------------------------------
void loop() {
  /*
    Serial.print("\nXML-Link: ");
    Serial.println(getLink());
    delay(2000);
  */
  #if ( defined(WMMIELE))
  chkMIele();
  #endif
}