// Datei: pretzelgyrowasher.ino
/*
Hinweis für Leser - die nachstehenden Zeilen sind im Code anzupassen:
#define SSID "WLANDAHOAM"
#define PASSWORD "WPAPWLANDAHOAM"
#define DEVID_PIR "WM000001"
#define RPI_IP "192.168.123.49"
const int threshold = 78; 
const char rpiPost[] PROGMEM = {  "GET *URL* HTTP/1.1\nHost: 192.168.123.49\nAuthorization: Basic YWRtaW46cHdhZG1pbg==\nConnection: close\nContent-Type: application/x-www-form-urlencoded\nContent-Length: *LEN*\n\n\n\0"};
 */

#define SSID "WLANDAHOAM"
#define PASSWORD "WPAPWLANDAHOAM"
#define DEVID_PIR "WM000001"
#define RPI_IP "192.168.123.49"
#define MAILDELTA 3000
#define CHECKDELTA 180000 // 3 Minuten
// --------------------------------------------------------------------
#define MPU6050 0x68
#define MPU6050_xout 0x3B
#define MPU6050_yout 0x3D
#define MPU6050_zout 0x3F
#define MPU6050_pwr_mgmt_1 0x6B
#define MPU6050_pwr_mgmt_2 0x6C
#define MPU6050_config 0x1A
#define DEBUG true
// --------------------------------------------------------------------
#include <Wire.h>
const int threshold = 78;   // Empfindlichkeit Gyro-Sensors korrigieren 
const char rpiPost[] PROGMEM = {  "GET *URL* HTTP/1.1\nHost: 192.168.123.49\nAuthorization: Basic YWRtaW46cHdhZG1pbg==\nConnection: close\nContent-Type: application/x-www-form-urlencoded\nContent-Length: *LEN*\n\n\n\0"};
#include <SoftwareSerial.h>
SoftwareSerial esp8266(11, 12); // RX, TX

int WM_SENSOR_0_1_2 = 3; // Standardmaessig AUS
int i = 0;
// --------------------------------------------------------------------
void setup(){
  Serial.begin(115000);
  Wire.begin();
  delay(1000);
  // Powermanagement aufrufen
  // Sensor schlafen und Reset, Clock wird zunächst von Gyro-Achse Z verwendet  
  // Serial.println("Powermanagement aufrufen - Reset");
  SetMPU6050(MPU6050_pwr_mgmt_1, 0x80);
  // Kurz warten
  delay(500);
  // Powermanagement aufrufen
  // Wecken und Clock von Gyroskop-Achse X verwenden
  // Serial.println("Powermanagement aufrufen - Clock festlegen");
  SetMPU6050(MPU6050_pwr_mgmt_1, 0x03);
  
  delay(500);
  // Default => Acc=260Hz, Delay=0ms, Gyro=256Hz, Delay=0.98ms, Fs=8kHz
  // Serial.println("Konfiguration aufrufen - Default Acc = 260Hz, Delay = 0ms");
  SetMPU6050(MPU6050_config, 0x00);
  // Leerzeichen
  Serial.println("");
  Serial.println ("[MPU6050] Konfiguration abgeschlossen.");  
  // WIFI  
  esp8266.begin(19200);
  if (!espConfig()) serialDebug();
  else debug("[ESP8266] Config OK");
  if (sendCom("AT+PING=\"www.franzis.de\"", "OK"))  {
    // Serial.println("[ESP8266] Ping OK");
    digitalWrite(13, HIGH);
  }  else  {
    Serial.println("[ESP8266] Ping Fehler");
  }
}
// ---------------------------------------------------------------------------------------
void loop(){
  byte result[14];
  // Anfangs Adresse von Beschleunigungssensor-Achse X
  result[0] = MPU6050_xout; // 0x3B
   // Aufruf des MPU6050 Sensor
  Wire.beginTransmission(MPU6050);
  // Anfangsadresse verwenden.
  Wire.write(result[0]);
  Wire.endTransmission();
  // 14 Bytes kommen als Antwort
  Wire.requestFrom(MPU6050, 14);
  // Bytes im Array ablegen
  for(int i = 0; i < 14; i++)
  {
    result[i] = Wire.read();
  }
  // Zwei Bytes sind ein Achsen-Wert -> werden per Bit Shifting verbunden.
  // Beschleunigungssensor X, Y, Z
  int acc_X = (((int)result[0]) << 8) | result[1]; // 0x3B (ACCEL_XOUT_H) & 0x3C (ACCEL_XOUT_L)
  int acc_Y = (((int)result[2]) << 8) | result[3]; // 0x3D (ACCEL_YOUT_H) & 0x3E (ACCEL_YOUT_L)
  int acc_Z = (((int)result[4]) << 8) | result[5]; // 0x3F (ACCEL_ZOUT_H) & 0x40 (ACCEL_ZOUT_L)
  // Temperatur-Sensor
  int temp = (((int)result[6]) << 8) | result[7]; // 0x41 (TEMP_OUT_H) & 0x42 (TEMP_OUT_L)
  // Gyroskop-Sensor
  int gyr_X = (((int)result[8]) << 8) | result[9]; // 0x43 (GYRO_XOUT_H) & 0x44 (GYRO_XOUT_L)
  int gyr_Y = (((int)result[10]) << 8) | result[11]; // 0x45 (GYRO_YOUT_H) & 0x46 (GYRO_YOUT_L)
  int gyr_Z = (((int)result[12]) << 8) | result[13]; // 0x47 (GYRO_ZOUT_H) & 0x48 (GYRO_ZOUT_L)
  // Ausgabe
  Serial.print("[MPU6050] Temperatur : ");
  Serial.print(temp/340.00+36.53); // Temperatur in Celsius
  Serial.println(" C");
  // X Gyro Achse wackelt
  if (gyr_X > threshold){
    Serial.print("Gyrosensor ausgeloest X:\t");
    Serial.print(gyr_X); Serial.print("\t");
    Serial.println("\t");
// -----------------------------------------------------
// WM –CHECK
// 
    if (WM_SENSOR_0_1_2 == 0){
      // wurde schon gestartet
      WM_SENSOR_0_1_2 = 1;
      };
/*
  WM_SENSOR_0_1_2
  Status-Wert 
  0 - WM-Start (wechseln von Ruhe in lfd. Betrieb)
  1 - WM-im Einsatz (lfd. Betrieb)
  2 - WM-Ende (wechseln von lfd. in Ruhe)
  3 - AUS
 */

    } // Sensor nicht ausgelöst oder schon fertig
    else {
      if (WM_SENSOR_0_1_2 == 1){
       // im lfd. Betrieb und nun wechseln in Ruhezustand 
       WM_SENSOR_0_1_2 = 2;
       // Wäsche ist nun fertig
       // -> Benachrichtigung
      }
    else if (WM_SENSOR_0_1_2 == 2){
      // WM ist in Ruhezustand -> in Ursprungszustand zurück
      // 
      WM_SENSOR_0_1_2 = 0;
      i = 0;
      }
      else {
        WM_SENSOR_0_1_2 = 0;
        i = 0;
      }
    }
    
    // Status an PHP-Seite
    if (sendRpiPost(DEVID_PIR, WM_SENSOR_0_1_2)){ 
          debug("[ESP8266] Update Send");
          Serial.print("[ESP8266] Update - Wert: " + String(WM_SENSOR_0_1_2));
          Serial.print(" von Sensor ");
          Serial.print(DEVID_PIR);
          Serial.println(" wurde auf Server uebertragen.");
          delay(MAILDELTA);  
          }        else {
            debug("[ESP8266] Sensor hat Bewegung erfasst, Benachrichtigung nicht moeglich.");          
            Serial.print("[ESP8266] Update - Wert: " + String(WM_SENSOR_0_1_2));
            Serial.print(" von Sensor ");         
            Serial.println(DEVID_PIR);
          } 
     // nächste Prüfung wieder in CHECKDELTA (MILLISEKUNDEN)
     delay(CHECKDELTA);

}
//-----------------------------------------Config ESP8266------------------------------------
boolean espConfig(){
  boolean success = true;
  esp8266.setTimeout(5000);
  success &= sendCom("AT+RST", "ready");
  esp8266.setTimeout(1000);
  if (configStation(SSID, PASSWORD)) {
    success &= true;
    debug("[ESP8266] WLAN Connected");
    debug("[ESP8266] IP :");
    debug(sendCom("AT+CIFSR"));
  }
  else
  {
    success &= false;
  }
  success &= sendCom("AT+CIPMUX=0", "OK");
  success &= sendCom("AT+CIPMODE=0", "OK");
  return success;
}
//----------------------------------------------------------------------------------
boolean configStation(String vSSID, String vPASSWORT){
  boolean success = true;
  success &= (sendCom("AT+CWMODE=1", "OK"));
  esp8266.setTimeout(20000);
  success &= (sendCom("AT+CWJAP=\"" + String(vSSID) + "\",\"" + String(vPASSWORT) + "\"", "OK"));
  esp8266.setTimeout(1000);
  return success;
}
//-----------------------------------------------Control  ESP--------------------------------------
boolean sendCom(String command, char respond[]){
  esp8266.println(command);
  if (esp8266.findUntil(respond, "ERROR"))  {
    return true;
  }  else  {
    debug("[ESP8266] ESP SEND ERROR: " + command);
    return false;
  }
}
//-----------------------------------------
String sendCom(String command){
  esp8266.println(command);
  return esp8266.readString();
}
//-----------------------------------------RPI-Server ------------------------------------
boolean sendRpiPost(String dev_id, int value){
  boolean success = true;
  String Host = RPI_IP;
  String  Subpage = "/pretzelgyrowasher.php?dev="+dev_id+"&status="+value;
  success &= sendCom("AT+CIPSTART=\"TCP\",\"" + Host + "\",80", "OK");
  if (success){
  String urlBuffer;
  for (int i = 0; i <= sizeof(rpiPost); i++)   {
    char myChar = pgm_read_byte_near(rpiPost + i);
    urlBuffer += myChar;
  }
  urlBuffer.replace("*URL*", Subpage);
  urlBuffer.replace("*APPEND*", String("dev="+dev_id+"&status="+value));
  urlBuffer.replace("*LEN*", String(urlBuffer.length()));
  if (sendCom("AT+CIPSEND=" + String(urlBuffer.length() + 2), ">")) {
      esp8266.println(urlBuffer);
      // Serial.println(urlBuffer);
      esp8266.find("SEND OK");
      if (!esp8266.find("CLOSED")) success &= sendCom("AT+CIPCLOSE", "OK");
      }   else  {
        // Serial.print("FHELER!!!");
        success = false;
     }
   } 
   return success;
}
// ---------------------------------------------------------------------------------------
void SetMPU6050(byte reg, byte setting){
   // Aufruf des MPU6050 Sensor
  Wire.beginTransmission(MPU6050);
  // Register Aufruf
  Wire.write(reg);
  // Einstellungsbyte für das Register senden
  Wire.write(setting);
  Wire.endTransmission();
}
//-------------------------------------------------Debug Functions---------------------------------
void serialDebug() {
  while (true)  {
    if (esp8266.available())
      Serial.write(esp8266.read());
    if (Serial.available())
      esp8266.write(Serial.read());
  }
}
//-----------------------------------------
void debug(String Msg){
  if (DEBUG)  {
    Serial.println(Msg);
  }
}
// ---------------------------------------------------------------------------------------
