#include <Ethernet.h>
#include <SPI.h>
// Datei: sendGMXMail.ino 
// Verzeichnis \smtpmail
byte mac[] = {  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};
byte ip[] = { 192, 168, 123, 35 }; // IP Arduino
byte server[] = {212, 227, 17, 168}; // IP Mailserver - hier GMX

char *mail_adr = " ihre.mailadresse@gmx.de ";        // Empfaenger fuer E-Mail-Nachricht
char *frommail_adr = "arduino.mailadresse@gmx.de";        // Sender E-Mail-Nachricht

EthernetClient client;
void setup()
{
  Serial.begin(9600);
  Serial.println("Verbindungsaufbau...");
  delay(1000);

  if (Ethernet.begin(mac))
    Serial.println("IP ist OK");
  else
  {
    Serial.println("Fehler aufgetreten!");
    while (1);
    // Endlosschleife bis zum Reset
  }
  char message[160];
  sprintf(message, "Nachricht vom Arduino");
  sendGMXMail(message, mail_adr, frommail_adr);
}

// boolean sendGMXMail(char *message, char *mail_adr, char *frommail_adr)
void sendGMXMail(char *message, char *mail_adr, char *frommail_adr)
{
  char mailfrom[160];
  char mailto[160];
  if (client.connect(server, 25)) // SMTP-Port 25
  {
    Serial.println("Befehle werden gesendet...");
    client.println("ehlo homeSweetHome");
    delay(500);
    while (client.available()) Serial.write(client.read());
    client.println("auth login");
    delay(500);
    while (client.available()) Serial.write(client.read());
    client.println("beispielfuerbase64cod==");
    // Emailadresse in Base64 kodieren!
    delay(500);
    while (client.available()) Serial.write(client.read());
    client.println("pwbeispielfuerbase64");
    // Passwort in Base64 kodieren!
    delay(500);
    while (client.available()) Serial.write(client.read());
    Serial.print("MAIL FROM:<");
    Serial.print(frommail_adr);
    Serial.println(">");
    client.print("MAIL FROM:<");
    client.print(frommail_adr);    
    client.println(">");
    delay(500);
    while (client.available()) Serial.write(client.read());
    Serial.print("RCPT TO:<");
    Serial.print(mail_adr);
    Serial.println(">");
    client.print("RCPT TO:<");
    client.print(mail_adr);    
    client.println(">");
    delay(500);
    client.println("DATA");
    while (client.available()) Serial.write(client.read());
    Serial.print("FROM: ");
    Serial.println(frommail_adr);
    client.print("FROM: ");
    client.println(frommail_adr);
    delay(500);
    while (client.available()) Serial.write(client.read());
    Serial.print("TO: ");
    Serial.println(mail_adr);
    client.print("TO: ");
    client.println(mail_adr);
    delay(500);
    client.println("SUBJECT: DoorController Email");
    client.println();
    delay(500);
    while (client.available()) Serial.write(client.read());
    client.println(message);
    client.println(".");
    delay(500);
    while (client.available()) Serial.write(client.read());
    client.println("QUIT");
    delay(500);
    while (client.available()) Serial.write(client.read());
    client.stop();
//    return true;
  }
  else
  {
    Serial.println("Verbindung nicht moeglich!");
//    return false;
  }

}
void loop()
{
}
