#!/bin/bash
# WLAN-Lampe(n)-Schalten mit dem Raspberry Pi
# GPIO
GPIO_SW1=22 # pin 15 - wiring 3
GPIO_SW2=23 # pin 16 - wiring pi 4
GPIO_SW3=24 # pin 18 - wiring pi 5
GPIO_SW4=25 # pin 22 - wiring pi 6
GPIO_SW5=17 # pin 11 - wiring 0
GPIO_LED1=18 # Pin  12 - wiring pi 1
GPIO_LED2=15 # Pin 10 - wiring pi 16
GPIO_LED3=14 # Pin 8 - wiring pi  15

# init
gpio -g mode $GPIO_SW1 in;
gpio -g mode $GPIO_SW2 in;
gpio -g mode $GPIO_SW3 in;
gpio -g mode $GPIO_SW4 in;
gpio -g mode $GPIO_SW5 in;
gpio -g mode $GPIO_LED1 out;
gpio -g mode $GPIO_LED2 out;
gpio -g mode $GPIO_LED3 out;
#Schalter_Status
SW1_ALLONOFF=0;
SW2_COLOR=0;
SW3_FADEUP=0;
SW4_FADEDOWN=0;
SW5_ALARM=0;
#Schalter_Zaehler
iSW1_ALLONOFF=0;
iSW2_COLOR=0;
iSW3_FADEUP=0;
iSW4_FADEDOWN=0;
iSW5_ALARM=0;
#-------------------------------------------------------------------------
function inc_switch(){
        local name_switch=${1};
        local switch_wert=${2};
        # echo "Uebergeben wurde :" $name_switch " und " $switch_wert;
        local switch_wertneu=0;
        if [ ! -z "$switch_wert" ]; then
                local switch_wertneu=`echo $switch_wert+1 | bc`;
        fi;
        case "$name_switch" in
                "SW1_ALLONOFF") # SW_1
                iSW1_ALLONOFF=$switch_wertneu
                ;;

                "SW2_COLOR") # SW_2
                iSW2_COLOR=$switch_wertneu
                ;;

                "SW3_FADEUP") # SW_3
                iSW3_FADEUP=$switch_wertneu
                ;;

                "SW4_FADEDOWN") # SW_4
                iSW4_FADEDOWN=$switch_wertneu
                ;;

                "SW5_ALARM") # SW_5
                iSW5_ALARM=$switch_wertneu
                ;;
        esac
}
#-------------------------------------------------------------------------
function desc_switch(){
        local name_switch=${1};
        local switch_wert=${2};
        echo "Uebergeben wurde :" $name_switch " und " $switch_wert;
        local switch_wertneu=0;
        if [ ! -z "$switch_wert" ]; then
                local switch_wertneu=`echo $switch_wert-1 | bc`;
        fi
        if [ "$switch_wertneu" -lt 0 ]; then
                switch_wertneu=0;
        fi
        case "$name_switch" in
                "SW1_ALLONOFF") # SW_1
                iSW1_ALLONOFF=$switch_wertneu
                ;;

                "SW2_COLOR") # SW_2
                iSW2_COLOR=$switch_wertneu
                ;;

                "SW3_FADEUP") # SW_3
                iSW3_FADEUP=$switch_wertneu
                ;;

                "SW4_FADEDOWN") # SW_4
                iSW4_FADEDOWN=$switch_wertneu
                ;;

                "SW5_ALARM") # SW_5
                iSW5_ALARM=$switch_wertneu
                ;;
	esac
}
#-------------------------------------------------------------------------
while true; do
	ZAEHLER=0;
# wird ein "Schliesser" als Schalter verwendet, dann Parameter 0
# bei einem "Oeffner als Parameter hier 1
        if [ $(gpio -g read $GPIO_SW1) -eq  0 ]; then
                echo "GPIO_SW1" $GPIO_SW1 "gedrueckt";
		echo "Funktion: Ein/Ausschalten Beleuchtung / Alle Lampen";
		gpio -g write $GPIO_LED1 1;
		inc_switch SW1_ALLONOFF $iSW1_ALLONOFF;
		if [ "$iSW1_ALLONOFF" -eq 1 ]; then # erster druck, jetzt einschalten
			python switch1-an.py;
		else #ausschalten
			python switch1-aus.py;
			gpio -g write $GPIO_LED1 0;
			iSW1_ALLONOFF=0;
		fi;
        elif [ $(gpio -g read $GPIO_SW2) -eq  0 ]; then
                echo "GPIO_SW2" $GPIO_SW2 "gedrueckt";
		echo "Funktion: Farb-Auswahl (Bspw. violett=0, .. 15..)";
		python switch2.py -c 1 $iSW2_COLOR;
		inc_switch SW2_COLOR  $iSW2_COLOR
		if [ "$iSW2_COLOR" -eq 16 ]; then iSW2_COLOR=0;fi;
		while [ $ZAEHLER -le "$iSW2_COLOR" ]; do
			gpio -g write $GPIO_LED2 1;
			ZAEHLER=`echo $ZAEHLER+1 | bc`;
			sleep 0.2;
			gpio -g write $GPIO_LED2 0;
		done;
        elif [ $(gpio -g read $GPIO_SW3) -eq  0 ]; then
                echo "GPIO_SW3" $GPIO_SW3 "gedrueckt";
		echo "Funktion: Heller (Dimmen der Helligkeit)";
		python switch3.py;
		inc_switch SW3_FADEUP  $iSW3_FADEUP
        elif [ $(gpio -g read $GPIO_SW4) -eq  0 ]; then
                echo "GPIO_SW4" $GPIO_SW4 "gedrueckt";
		echo "Funktion: Dunkler (Dimmen der Helligkeit)";
		python switch4.py;
		inc_switch SW4_FADEDOWN  $iSW4_FADEDOWN
        elif [ $(gpio -g read $GPIO_SW5) -eq  0 ]; then
                echo "GPIO_SW5" $GPIO_SW5 "gedrueckt";
		echo "Funktion: Alarm-Schalter";
		inc_switch SW5_ALARM  $iSW5_ALARM
		if [ "$iSW5_ALARM" -eq 1 ]; then # erster druck, jetzt alarm einschalten
			python switch5-an.py;
			gpio -g write $GPIO_LED3 1;
		else # Alarm aus.
			python switch5-aus.py;
			gpio -g write $GPIO_LED3 0;
		fi; 
        fi;
	#
sleep 0.1
done
exit 0
#---------------------- EOF --------------------------------














