#!/bin/bash
#------------------------------------------------------------
# Shell-Steuerung fuer Wifi-Lampen
# Datei : wifi-led.sh
#------------------------------------------------------------
if [ -z "$1" ] ; then
	echo "[Fehler] Parameter erforderlich..."
	echo " Beispiel: $0 alles_an"
	exit 1
fi
parameter="$1"
#------------------------------------------------------------
wlan_ip_address="192.168.123.100"
udp_port="50000"
#------------------------------------------------------------
alles_an="\x22\x00\x55" # alle verbundenen lampen an
alles_aus="\x21\x00\x55" # alles aus
zone1_an="\x38\x00\x55" # Gruppe 1 an
zone1_aus="\x3B\x00\x55" # Gruppe 1 aus
zone2_an="\x3D\x00\x55" # Gruppe 2 an
zone2_aus="\x33\x00\x55" # Gruppe 2 aus
zone3_an="\x37\x00\x55" # Gruppe 3 an
zone3_aus="\x3A\x00\x55" # Gruppe 3 aus
zone4_an="\x32\x00\x55" # Gruppe 4 an
zone4_aus="\x36\x00\x55" # Gruppe 4 aus
tuerkis="\x20\x55\x55" # Farbe: tuerkis
blau="\x20\x11\x55" # Farbe: blau
gruen="\x20\x66\x55" # Farbe: gruen
orange="\x20\x99\x55" # Farbe: orange
rot="\x20\xaa\x55" # Farbe: rot
pink="\x20\xcc\x55" # Farbe: pink
rosa="\x20\xee\x55" # Farbe: rosa
fw="\x27\x00\x55" #nchstes Programm
bw="\x28\x00\x55" #vorheriges Programm
fast="\x25\x00\x55" #schneller
slow="\x26\x00\x55" #langsamer
rgb_led_all_off="\x41\x00\x55" # RGBW COLOR LED ALL OFF
rgb_led_all_on="\x42\x00\x55" # RGBW COLOR LED ALL ON
disco_speed_slow="\x43\x00\x55" # DISCO SPEED SLOWER
disco_speed_fast="\x44\x00\x55" # DISCO SPEED FASTER
group1_all_on="\x45\x00\x55" # GROUP 1 ALL ON (SYNC/PAIR RGB+W Bulb within 2 seconds of Wall Switch Power being turned ON)
group1_all_off="\x46\x00\x55" # GROUP 1 ALL OFF
group1_all_on="\x47\x00\x55" # GROUP 2 ALL ON (SYNC/PAIR RGB+W Bulb within 2 seconds of Wall Switch Power being turned ON)
group2_all_off="\x48\x00\x55" # GROUP 2 ALL OFF
group3_all_on="\x49\x00\x55" # GROUP 3 ALL ON (SYNC/PAIR RGB+W Bulb within 2 seconds of Wall Switch Power being turned ON)
group3_all_off="\x4A\x00\x55" # GROUP 3 ALL OFF
group4_all_on="\x4B\x00\x55" # GROUP 4 ALL ON (SYNC/PAIR RGB+W Bulb within 2 seconds of Wall Switch Power being turned ON)
group4_all_off="\x4C\x00\x55" # GROUP 4 ALL OFF
disco_mode="\x4D\x00\x55" # DISCO MODE
set_color_white_all="\x42\x00\x55" # SET COLOR TO WHITE (GROUP ALL) 100ms followed by: \xC2
set_color_white_group1="\x45\x00\x55" # SET COLOR TO WHITE (GROUP 1) 100ms followed by: \xC5
set_color_white_group2="\x47\x00\x55" # SET COLOR TO WHITE (GROUP 2) 100ms followed by: \xC7
set_color_white_group3="\x49\x00\x55" # SET COLOR TO WHITE (GROUP 3) 100ms followed by: \xC9
set_color_white_group4="\x4B\x00\x55" # SET COLOR TO WHITE (GROUP 4) 100ms followed by: \xCB
#------------------------------------------------------------
eval parameter=\$$parameter
echo -n -e "$parameter" >/dev/udp/"$wlan_ip_address"/"$udp_port"
time_intervall=0.1; # 100ms
#------------------------------------------------------------
if [[ "$parameter" = '\x42\x00\x55' ]]; then
	sleep $time_intervall;
	parameter2="\xC2\x00\x55";
	echo -n -e "$parameter2" >/dev/udp/"$wlan_ip_address"/"$udp_port"
elif [[ "$parameter" = '\x45\x00\x55' ]]; then
	sleep $time_intervall;
	parameter2="\xC5\x00\x55";
	echo -n -e "$parameter2" >/dev/udp/"$wlan_ip_address"/"$udp_port"
elif [[ "$parameter" = '\x47\x00\x55' ]]; then
	sleep $time_intervall;
	parameter2="\xC7\x00\x55";
	echo -n -e "$parameter2" >/dev/udp/"$wlan_ip_address"/"$udp_port"
elif [[ "$parameter" = '\x49\x00\x55' ]]; then
	sleep $time_intervall;
	parameter2="\xC9\x00\x55";
	echo -n -e "$parameter2" >/dev/udp/"$wlan_ip_address"/"$udp_port"
elif [[ "$parameter" = '\x4B\x00\x55' ]]; then
	sleep $time_intervall;
	parameter2="\xCB\x00\x55";
	echo -n -e "$parameter2" >/dev/udp/"$wlan_ip_address"/"$udp_port"
fi
#------------------------------------------------------------
exit 0
